# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
#
# Copyright 1997-2010 Oracle and/or its affiliates. All rights reserved.
#
# Oracle and Java are registered trademarks of Oracle and/or its affiliates.
# Other names may be trademarks of their respective owners.
#
# The contents of this file are subject to the terms of either the GNU
# General Public License Version 2 only ("GPL") or the Common
# Development and Distribution License("CDDL") (collectively, the
# "License"). You may not use this file except in compliance with the
# License. You can obtain a copy of the License at
# http://www.netbeans.org/cddl-gplv2.html
# or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
# specific language governing permissions and limitations under the
# License.  When distributing the software, include this License Header
# Notice in each file and include the License file at
# nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
# particular file as subject to the "Classpath" exception as provided
# by Oracle in the GPL Version 2 section of the License file that
# accompanied this code. If applicable, add the following below the
# License Header, with the fields enclosed by brackets [] replaced by
# your own identifying information:
# "Portions Copyrighted [year] [name of copyright owner]"
#
# Contributor(s):
#
# The Original Software is NetBeans. The Initial Developer of the Original
# Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
# Microsystems, Inc. All Rights Reserved.
#
# If you wish your version of this file to be governed by only the CDDL
# or only the GPL Version 2, indicate your decision by adding
# "[Contributor] elects to include this software in this distribution
# under the [CDDL or GPL Version 2] license." If you do not indicate a
# single choice of license, a recipient has the option to distribute
# your version of this file under either the CDDL, the GPL Version 2 or
# to extend the choice of license to its licensees as provided above.
# However, if you add GPL Version 2 code and therefore, elected the GPL
# Version 2 license, then the option applies only if the new code is
# made subject to such option by the copyright holder.

# Basic Box Model Module

$category=box

clear=none | left | right | both | inherit | initial

display=inline | block | inline-block | list-item | run-in | compact | table | \
        inline-table | table-row-group | table-header-group | table-footer-group | \
        table-row | table-column-group | table-column | table-cell | table-caption | \
        ruby | ruby-base | ruby-text | ruby-base-group | ruby-text-group | \
        <template>| none | inherit | initial

#define
@template=!anything

#page-floats defined in Generated content for paged media
float=[ left | right | top | bottom | start | end | none | <page-floats> ] && contour? 

# --- margin ---
margin=[<box-edge-size>]{1,4} | inherit | initial

margin-top=<box-edge-size>
margin-right=<box-edge-size>
margin-bottom=<box-edge-size>
margin-left=<box-edge-size>

# --- padding ---
padding=[<box-edge-size>]{1,4} | inherit | initial

padding-top=<box-edge-size>
padding-right=<box-edge-size>
padding-bottom=<box-edge-size>
padding-left=<box-edge-size>

@box-edge-size=<length> | <percentage> | auto
# ------

#marquee-direction=forward | reverse

marquee-loop=!non-negative-integer | infinite

#marquee-speed=slow | normal | fast

#marquee-style=scroll | slide | alternate

max-width;max-height= <length> | <percentage> | available | min-content | max-content | fit-content | none 

min-width;min-height= <length> | <percentage> | available | min-content | max-content | fit-content 

overflow=[ visible | hidden | scroll | auto | no-display | no-content ]{1,2}

overflow-style=<basic_box_model-overflow-style> || <marquee_model-overflow-style>

@basic_box_model-overflow-style=auto | [[scrollbar | panner | move | marquee] [, [scrollbar | panner | move | marquee]]*]


overflow-x;overflow-y=visible | hidden | scroll | auto | no-display | no-content

rotation=<angle>

rotation-point=<bg-pos>

visibility=visible | hidden | collapse

width=[ <length> | <percentage> ] && [border-box | content-box]? | available | min-content | max-content | fit-content | auto

height=[ <length> | <percentage> ] && [border-box | content-box]? | available | min-content | max-content | fit-content | complex | auto 